=== debian/changelog ===
systemc (3.0.2-1) unstable; urgency=medium

  * [9f2e7de] New upstream version 3.0.2
  * [bc7000f] Drop doc-targets.patch, applied upstream
  * [a14fa2c] d/control: update standards version to 4.7.2
  * [a9f3239] d/not-installed: add INSTALL_USING_AUTOTOOLS.md
  * [7952468] Update copyright years

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 05 Nov 2025 13:44:46 +0100
