=== debian/tests/control ===
Tests: test-linking.sh
Depends:
 build-essential,
 libsystemc-dev,
 pkg-config,
Restrictions: allow-stderr
